function HJ(x::Array,lb::Array,ub::Array,Delta::Real,tol::Real,maxit::Int,f::Function,verbosity)
# il numero delle variabili è dato dalla lunghezza
# del vettore punto iniziale x
n = length(x)  

function isfeasible(x)
	for i=1:n
		if x[i] < lb[i] || x[i] > ub[i]
			return false
		end
	end
	return true
end

# la matrice delle direzioni di ricerca è D = [I -I]
# il numero di colonne di D è m = 2*n
D = [eye(n,n) -eye(n,n)]
m = size(D,2)

k     = 0
fx    = f(x)
nf    = 1

if verbosity > 0
	@printf("+-----------------------------------------+\n")
	@printf("|         Hooke & Jeeves                  |\n")
	@printf("+-----------------------------------------+\n")

	@printf("   k     nf      fx           Delta\n")
end
while (k <= maxit) && (Delta > tol)
      k  = k+1
      y  = copy(x)
      fy = f(x)
      for i = 1:m
      	  d  = D[:,i]
		  if isfeasible(y+Delta*d)
	      	  ft = f(y+Delta*d)
			  nf = nf+1
			  if ft < fy
	    		 y  = y+Delta*d
	     		 fy = ft
			  end
		  end
      end
      if fy < fx
      	 dp = y - x
	     z  = y + dp
		 if isfeasible(z)
			fz = f(z)
			nf = nf + 1

			for i = 1:m
				d  = D[:,i]
				if isfeasible(z+Delta*d)
					ft = f(z+Delta*d)
					nf = nf+1
					if ft < fz
					z  = z+Delta*d
					fz = ft
					end
				end
			end
		 else
		 	fz = fy
	     end
		 if fz < fy
		    x  = z
		    fx = fz
		 else
		    x  = y
		    fx = fy
		 end
      else
	     Delta = Delta/2
      end
	  if verbosity > 0
	      @printf("%4d %6d %13.6e %13.6e\n",k,nf,fx,Delta)
	  end
end
return (x,fx)
end

